//
//  HTBSDK.h
//  HTBSDK
//
//  Created by Magic Liu on 2023/2/13.
//

#import <UIKit/UIKit.h>
typedef void(^HTBCallback)(NSDictionary *resultDic,BOOL isSuccess);

@interface HTBSDK : NSObject
-(instancetype)init NS_UNAVAILABLE;
+(instancetype)new NS_UNAVAILABLE;
-(id)copy NS_UNAVAILABLE;
-(id)mutableCopy NS_UNAVAILABLE;
+ (instancetype)instance;

#pragma mark  ====================================== 以下全是对外开放接口
// 初始化
-(void)sdkInit:(HTBCallback)initCallback withLoginoutCallback:(HTBCallback)loginoutCallback;

// 登录
-(void)login:(HTBCallback)callback;

// 登出
-(void)loginOut;

// 上报
-(void)report:(NSDictionary *)roleDict andCallBack:(HTBCallback)reportCallback;

// 支付
-(void)pay:(NSDictionary *)payDict andCallback:(HTBCallback)payCallback;

// 生命周期部分
- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions;

- (BOOL)application:(UIApplication *)application openURL:(NSURL *)url
  sourceApplication:(NSString *)sourceApplication
         annotation:(id)annotation;

- (BOOL)application:(UIApplication *)application openURL:(NSURL *)url options:(NSDictionary<UIApplicationOpenURLOptionsKey, id> *)options;

- (BOOL)application:(UIApplication *)application handleOpenURL:(NSURL *)url;

- (void)applicationWillEnterForeground:(UIApplication *)application;
- (void)applicationWillResignActive:(UIApplication *)application;

- (UIInterfaceOrientationMask)application:(UIApplication *)application supportedInterfaceOrientationsForWindow:(UIWindow *)window;

- (void)application:(UIApplication *)application didRegisterForRemoteNotificationsWithDeviceToken:(NSData *)deviceToken;

- (void)application:(UIApplication *)application didFailToRegisterForRemoteNotificationsWithError:(NSError *)error;

- (void)application:(UIApplication *)application didReceiveRemoteNotification:(NSDictionary *)userInfo;


- (void)applicationDidBecomeActive:(UIApplication *)application;

- (void)applicationDidEnterBackground:(UIApplication *)application;

- (void)applicationWillTerminate:(UIApplication *)application;

- (BOOL)application:(UIApplication *)application continueUserActivity:(NSUserActivity *)userActivity restorationHandler:(void(^)(NSArray * restorableObjects))restorationHandler;

@end

