//
//  ZZSevenSDK.h
//  ZZSevenSDKFramework
//
//  Created by 司墨网络 on 2023/6/1.
//

#import <UIKit/UIKit.h>
#import <Foundation/Foundation.h>

#import <ZZSevenSDKFramework/ZZSevenSDKLoginBlockModel.h>
#import <ZZSevenSDKFramework/ZZSevenSDKCreateRoleModel.h>

#import <ZZSevenSDKFramework/ZZSevenSDKLogoutModel.h>
#import <ZZSevenSDKFramework/ZZSevenSDKPayInfoModel.h>

NS_ASSUME_NONNULL_BEGIN

@protocol ZZSevenSDKDelegate <NSObject>

@required
- (void)SDKInitSuccess;
- (void)SDKInitFailWithErrorMsg:(NSString *)errorMsg;
- (void)logoutWithResult:(ZZSevenSDKLogoutModel *)logoutModel;

@end

@interface ZZSevenSDK : NSObject

+ (id)sharedInstance;
- (void)initSDKWithDelegate:(id)delegate;
- (void)loginWithSuccessBlock:(void(^)(ZZSevenSDKLoginBlockModel *loginModel))successBlock
                    failBlock:(void(^)(ZZSevenSDKLoginBlockModel *loginModel))failBlock;
- (void)roleCreateWithUserInfo:(ZZSevenSDKCreateRoleModel *)createRoleModel;
- (void)setGameAccountWithUserInfo:(ZZSevenSDKCreateRoleModel *)createRoleModel;
- (void)upLevelWithUserInfo:(ZZSevenSDKCreateRoleModel *)createRoleModel;

- (void)payWithPayInfoModel:(ZZSevenSDKPayInfoModel *)payInfoModel
               successBlock:(void(^)(void))successBlock
                  failBlock:(void(^)(NSInteger code, NSString *errorMsg))failBlock;
- (void)exitWithSuccessBlock:(void(^)(void))successBlock
                   failBlock:(void(^)(void))failBlock;

- (void)initLogoutListenerWithDelegate:(id)logoutDelegate;
- (void)logout;

- (BOOL)application:(UIApplication *)application openURL:(NSURL *)url sourceApplication:(NSString *)sourceApplication annotation:(id)annotation;
//iOS10以上使用
- (BOOL)application:(UIApplication *)app openURL:(NSURL *)url options:(NSDictionary<UIApplicationOpenURLOptionsKey,id> *)options;
- (BOOL)application:(UIApplication *)application handleOpenURL:(NSURL *)url;
//程序将进入后台(即将变成非激活状态)
- (void)applicationWillResignActive:(UIApplication *)application;
//程序已经进入后台
- (void)applicationDidEnterBackground:(UIApplication *)application;
//推送消息时候，获取设备的tokenid
- (void)application:(UIApplication *)application didRegisterForRemoteNotificationsWithDeviceToken:(NSData *)deviceToken;
//tokenid获取失败时，做对应处理
- (void)application:(UIApplication *)application didFailToRegisterForRemoteNotificationsWithError:(NSError *)error;
//接收到推送消息处理 ios(3.0, 10.0)
- (void)application:(UIApplication *)application didReceiveRemoteNotification:(NSDictionary *)userInfo;
//接收到推送消息处理 收到推送消息时候 ios(7.0)
- (void)application:(UIApplication *)application didReceiveRemoteNotification:(NSDictionary *)userInfo fetchCompletionHandler:(void (^)(UIBackgroundFetchResult))completionHandler;
//程序将进入前台(将要进入活跃状态)
- (void)applicationWillEnterForeground:(UIApplication *)application;
//程序已经进入前台(已经进入活跃状态)
- (void)applicationDidBecomeActive:(UIApplication *)application;
//程序将要退出(通常用于保存数据和一些退出前的清理工作)
- (void)applicationWillTerminate:(UIApplication *)application;
//从其他APP跳转至当前APP时, 该方法会自动调用 Open Universal Links方式
- (BOOL)application:(UIApplication *)application continueUserActivity:(NSUserActivity *)userActivity restorationHandler:(void(^)(NSArray * restorableObjects))restorationHandler;
//系统内存不足，需要进行清理工作
- (void)applicationDidReceiveMemoryWarning:(UIApplication *)application;
//当系统时间发生改变时执行
- (void)applicationSignificantTimeChange:(UIApplication *)application;
//当程序载入后执行
- (void)applicationDidFinishLaunching:(UIApplication *)application;
- (UIInterfaceOrientationMask)application:(UIApplication *)application supportedInterfaceOrientationsForWindow:(UIWindow *)window;

@end

NS_ASSUME_NONNULL_END
